%define section free

Summary:        DOM4J
Name:           dom4j
Version:        1.4
Release:        2jpp
Epoch:          0
License:        BSD-style
URL:            http://www.dom4j.org/
Group:          Text Processing/Markup/XML
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://prdownloads.sourceforge.net/dom4j/dom4j-1.4.tar.gz
Source1:        dom4j_rundemo.sh
Source2:        dom4j_cookbook.pdf
Source3:        dom4j_cookbook.ps
Patch0:         dom4j-xpp2.1.10.patch
Patch1:         dom4j-AbstractTestCase.patch
Patch2:         dom4j-NodeComparator.patch
Patch3:         dom4j-build_xml.patch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.5
BuildRequires:  junit
BuildRequires:  junitperf
BuildRequires:  xpp2 >= 0:2.1.10-1jpp
BuildRequires:  jtidy
BuildRequires:  xerces-j2
BuildRequires:  msv-strict
BuildRequires:  xsdlib
BuildRequires:  relaxngDatatype
BuildRequires:  isorelax
BuildRequires:  jaxen-bootstrap
BuildRequires:  saxpath
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-apis
Requires:       xpp2 >= 0:2.1.10-1jpp
Requires:       xerces-j2
Requires:  msv-strict
Requires:  xsdlib
Requires:  relaxngDatatype
Requires:  isorelax
Requires:       jaxen
Requires:       saxpath
Requires:       xalan-j2
Requires:       xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dom4j is an Open Source XML framework for Java. dom4j allows you to read,
write, navigate, create and modify XML documents. dom4j integrates with 
DOM and SAX and is seamlessly integrated with full XPath support. 

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation
Requires:       dom4j >= 0:1.4-1jpp

%description demo
Samples for %{name}.

%package manual
Summary:        Manual for %{name}
Group:          Development/Documentation

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.


%prep
%setup -q -n %{name}-%{version}
# replace run.sh
cp %{SOURCE1} run.sh
# remove binary libs
find . -name "*.jar" -exec rm -f {} \;
# test input file name error
mv xml/test/mergetext.xml xml/test/mergeText.xml
# fix for deleted jars
mv build.xml build.xml.orig
sed -e '/unjar/d' build.xml.orig -e 's|,cookbook/\*\*,|,|' > build.xml
# fix samples to conform to 1.4 import syntax changes
for f in $(find src/samples -name "*.java"); do
	if [ $(dirname $f) = src/samples ]; then
		(echo "package samples;"; cat $f ) > src/samples/tmpf
	else
		sed \
		-e 's/^package /package samples./' \
		-e '/import [^.]\{1,\};/s/import /import samples./' \
		$f > src/samples/tmpf
	fi
	cp src/samples/tmpf $f
done
sed -e "s|/a/|/*[local-name()='a']/|" src/samples/LinkChecker.java > src/samples/tmpf
cp src/samples/tmpf src/samples/LinkChecker.java
rm -f src/samples/tmpf

%patch0
%patch1
%patch2
%patch3

%build
export CLASSPATH=$(build-classpath \
xpp2 \
jtidy \
xerces-j2 \
relaxngDatatype \
xsdlib \
isorelax \
msv-strict \
jaxen \
junit \
junitperf \
saxpath \
xalan-j2 \
xml-commons-apis \
)
# ant all test
ant all samples test

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/%{name}-core.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# manual
cp %{SOURCE2} build/doc/cookbook
cp %{SOURCE3} build/doc/cookbook

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/classes
cp -pr xml $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr src/samples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr build/classes/samples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/classes
cp -p build/classes/SimpleAppletDemo.class $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/classes
cp -p run.sh $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -p readme.html $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post demo
rm -f %{_datadir}/%{name}
ln -s %{name}-%{version} %{_datadir}/%{name}

%postun demo
if [ "$1" = "0" ]; then
  rm -f %{_datadir}/%{name}
fi

%post manual
rm -f %{_datadir}/doc/%{name}
ln -s %{name}-%{version} %{_datadir}/doc/%{name}

%postun manual
if [ "$1" = "0" ]; then
  rm -f %{_datadir}/doc/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc doc/license.html
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%doc build/doc

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%changelog

* Tue Jul 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-2jpp
- Replace non-free msv with free relaxngDatatype xsdlib isorelax msv-strict
- Relax some versioned dependencies

* Mon Jan 19 2004 Ralph Apel <r.apel@r-apel.de> - 0:1.4-1jpp
- First JPackage release
